function g = gradient_phi(x, varargin)
%GRADIENT_PHI Add your code here for evaluating the gradient of function phi(x) at x.
%
% Input
%
% x:        The point on which the gradient has to be evaluated.
% varargin: Dynamic cell for handling extra arguments from the user, see 
%           http://www.mathworks.co.uk/help/matlab/ref/varargin.html for
%           details.
%
% Output
%
% g: gradient of phi(x) at point x.

%% Example
% In this particular example phi(x) is the logistic regression function, 
% varargin{1} = X (the matrix of training samples) and varargin{2} = labels
% (the labels of the training samples.)

Xx  = varargin{1}*x;
yXx = varargin{2}.*Xx;

t = 1./(1+exp(-yXx));
g = varargin{1}.'*(varargin{2}.*(t - 1));

end