function [nwtn,  rlrs, pcgi, Preconditioner]  = PCG_wrapper(PCG, Hessian, g, opts)

switch lower(opts.PCG_method)
    case 'lbfgs'
        [nwtn, rlrs, pcgi, Preconditioner]  = lbfgs_wrapper(PCG, Hessian, g, opts);  
    case 'ls_diag_pcg'
        [nwtn, rlrs, pcgi, Preconditioner]  = ls_diag_pcg_wrapper(PCG, Hessian, g, opts);
    case 'lg_diag_pcg'
        [nwtn, rlrs, pcgi, Preconditioner]  = lg_diag_pcg_wrapper(PCG, Hessian, g, opts);
    case 'tv_pcg'
        [nwtn, rlrs, pcgi, Preconditioner]  = tv_pcg_wrapper(PCG, Hessian, g, opts);
    case 'analysis_pcg'
        [nwtn, rlrs, pcgi, Preconditioner]  = analysis_pcg_wrapper(PCG, Hessian, g, opts);
    otherwise % Use no preconditioner
        Preconditioner = @(q) q;
        [nwtn, rlrs, pcgi] = linear_solver(Hessian,-g,opts.tolpcg,...
                                              opts.mxitrpcg,[]);
end
assignin('caller','PCG',PCG);
assignin('caller','opts',opts);
end